use tokio::sync::mpsc;

pub struct Signal {
    receiver:mpsc::Receiver<()>,
    sender:mpsc::Sender<()>,
}
impl Signal {
    pub fn new() -> Self
    {
        let (sender, receiver) = mpsc::channel::<()>(32);
        Self {
            receiver:receiver,
            sender:sender,
        }
    }

    pub async fn wait(&mut self)
    {
        self.receiver.recv().await;
    }

    pub fn register(&self) -> mpsc::Sender<()>
    {
        self.sender.clone()
    }
}
